package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.MsgAccountDetail;
import com.sa.ibiz.demo.demo.service.MsgAccountDetailService;
import com.sa.ibiz.demo.demo.service.dto.MsgAccountDetailSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/msgaccountdetail")
public class MsgAccountDetailResource
{
	@Autowired
	private MsgAccountDetailService service;


	@PostMapping(value = "/checkKey")
	public ResponseEntity<MsgAccountDetail> checkKey(@Validated @RequestBody MsgAccountDetail data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("组消息账户明细[checkKey]操作发生错误","MsgAccountDetail",data.getMsgaccountdetailid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<MsgAccountDetail> create(@Validated @RequestBody MsgAccountDetail data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("组消息账户明细[create]操作发生错误","MsgAccountDetail",data.getMsgaccountdetailid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<MsgAccountDetail> update(@Validated @RequestBody MsgAccountDetail data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("组消息账户明细[update]操作发生错误","MsgAccountDetail",data.getMsgaccountdetailid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<MsgAccountDetail> get(@Validated @PathVariable String id){
		MsgAccountDetail data=new MsgAccountDetail();
		data.setMsgaccountdetailid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("组消息账户明细[get]操作发生错误","MsgAccountDetail",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<MsgAccountDetail> remove(@Validated @RequestBody MsgAccountDetail data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("组消息账户明细[remove]操作发生错误","MsgAccountDetail",data.getMsgaccountdetailid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<MsgAccountDetail> getDraft(@Validated @RequestBody MsgAccountDetail data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("组消息账户明细[getDraft]操作发生错误","MsgAccountDetail","");
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<MsgAccountDetail>> searchDefaultPage(@Validated @RequestBody MsgAccountDetailSearchFilter filter){
		Page<MsgAccountDetail> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<MsgAccountDetail>> listDefault(@Validated @RequestBody MsgAccountDetailSearchFilter filter){
		List<MsgAccountDetail> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
